<?php

/**
 * Implementation of hook_views_default_views().
 */
function bt_tracker_views_default_views() {
  $base_path = '/'.dirname(drupal_get_path('module', 'bt_tracker')).'/images';

  $views = array();
  
  $view = new view;
  $view->name = 'bt_torrent_all_connections';
  $view->description = '';
  $view->tag = '';
  $view->view_php = '';
  $view->base_table = 'bt_tracker_connections';
  $view->is_cacheable = FALSE;
  $view->api_version = 2;
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $handler->override_option('relationships', array(
    'uid' => array(
      'label' => 'Users',
      'required' => 0,
      'id' => 'uid',
      'table' => 'bt_tracker_connections',
      'field' => 'uid',
      'relationship' => 'none',
    ),
  ));
  $handler->override_option('fields', array(
    'name' => array(
      'label' => 'Name',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'link_to_user' => 1,
      'overwrite_anonymous' => 0,
      'anonymous_text' => '',
      'exclude' => 0,
      'id' => 'name',
      'table' => 'users',
      'field' => 'name',
      'relationship' => 'uid',
    ),
    'bytes_uploaded' => array(
      'label' => '<img src="'.$base_path.'/uploaded.png" title="Bytes Uploaded"/>',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'file_size_display' => 'formatted',
      'exclude' => 0,
      'id' => 'bytes_uploaded',
      'table' => 'bt_tracker_connections',
      'field' => 'bytes_uploaded',
      'relationship' => 'none',
    ),
    'bytes_downloaded' => array(
      'label' => '<img src="'.$base_path.'/downloaded.png" title="Bytes Downloaded"/>',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'file_size_display' => 'formatted',
      'exclude' => 0,
      'id' => 'bytes_downloaded',
      'table' => 'bt_tracker_connections',
      'field' => 'bytes_downloaded',
      'relationship' => 'none',
    ),
    'php' => array(
      'label' => '<img src="'.$base_path.'/ratio.png" title="Ratio"/>',
      'code_style' => 'code_block',
      'output_source' => 'output',
      'php_code' => '?><span class="bf_profile_ratio"><?php print(bt_format_ratio($row->bytes_uploaded, $row->bytes_downloaded)); ?></span><?php
  ',
      'exclude' => '',
      'id' => 'php',
      'table' => 'views_php_extension',
      'field' => 'php',
      'relationship' => 'none',
    ),
    'bytes_left' => array(
      'label' => '<img src="'.$base_path.'/left.png" title="Bytes Left"/>',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'file_size_display' => 'formatted',
      'exclude' => 0,
      'id' => 'bytes_left',
      'table' => 'bt_tracker_connections',
      'field' => 'bytes_left',
      'relationship' => 'none',
    ),
    'upload_speed' => array(
      'label' => '<img src="'.$base_path.'/upload_speed.png" title="Upload Speed"/>',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'speed_display' => 'formatted',
      'exclude' => 0,
      'id' => 'upload_speed',
      'table' => 'bt_tracker_connections',
      'field' => 'upload_speed',
      'relationship' => 'none',
    ),
    'download_speed' => array(
      'label' => '<img src="'.$base_path.'/download_speed.png" title="Download Speed"/>',
      'alter' => array(
        'alter_text' => 0,
        'text' => '',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'speed_display' => 'formatted',
      'exclude' => 0,
      'id' => 'download_speed',
      'table' => 'bt_tracker_connections',
      'field' => 'download_speed',
      'relationship' => 'none',
    ),
    'php_1' => array(
      'label' => '<img src="'.$base_path.'/speed_ratio.png" title="Speed Ratio"/>',
      'code_style' => 'expression',
      'output_source' => 'result',
      'php_code' => 'bt_format_ratio($row->upload_speed, $row->download_speed)',
      'exclude' => '',
      'id' => 'php_1',
      'table' => 'views_php_extension',
      'field' => 'php',
      'relationship' => 'none',
    ),
    'last_announce' => array(
      'label' => 'Last Announce',
      'alter' => array(
        'alter_text' => 1,
        'text' => '<span class="bf_profile_datetime">[last_announce]</span>',
        'make_link' => 0,
        'path' => '',
        'link_class' => '',
        'alt' => '',
        'prefix' => '',
        'suffix' => '',
        'help' => '',
        'trim' => 0,
        'max_length' => '',
        'word_boundary' => 1,
        'ellipsis' => 1,
        'strip_tags' => 0,
        'html' => 0,
      ),
      'date_format' => 'custom',
      'custom_date_format' => 'Y.m.d H:i',
      'exclude' => 0,
      'id' => 'last_announce',
      'table' => 'bt_tracker_connections',
      'field' => 'last_announce',
      'relationship' => 'none',
    ),
    'peer_id' => array(
      'label' => 'Client',
      'code_style' => 'expression',
      'output_source' => 'result',
      'php_code' => '\'<span class="bf_profile_client">\'.torrent_compose_client_name_by_str($field).\'</span>\'',
      'exclude' => '',
      'id' => 'peer_id',
      'table' => 'bt_tracker_connections',
      'field' => 'peer_id',
      'relationship' => 'none',
    ),
  ));
  $handler->override_option('arguments', array(
    'fid' => array(
      'default_action' => 'empty',
      'style_plugin' => 'default_summary',
      'style_options' => array(),
      'wildcard' => 'all',
      'wildcard_substitution' => 'All',
      'title' => '',
      'breadcrumb' => '',
      'default_argument_type' => 'fixed',
      'default_argument' => '',
      'validate_type' => 'none',
      'validate_fail' => 'empty',
      'break_phrase' => 0,
      'not' => 0,
      'id' => 'fid',
      'table' => 'bt_tracker_connections',
      'field' => 'fid',
      'validate_user_argument_type' => 'uid',
      'validate_user_roles' => array(
        '2' => 0,
      ),
      'relationship' => 'none',
      'default_options_div_prefix' => '',
      'default_argument_user' => 0,
      'default_argument_fixed' => '',
      'default_argument_php' => '',
      'validate_argument_node_type' => array(
        'page' => 0,
        'profile' => 0,
        'story' => 0,
        'torrent' => 0,
      ),
      'validate_argument_node_access' => 0,
      'validate_argument_nid_type' => 'nid',
      'validate_argument_vocabulary' => array(),
      'validate_argument_type' => 'tid',
      'validate_argument_transform' => 0,
      'validate_user_restrict_roles' => 0,
      'validate_argument_php' => '',
    ),
  ));
  $handler->override_option('access', array(
    'type' => 'none',
  ));
  $handler->override_option('cache', array(
    'type' => 'none',
  ));
  $handler->override_option('style_plugin', 'table');
  $handler->override_option('style_options', array(
    'grouping' => '',
    'override' => 1,
    'sticky' => 0,
    'order' => 'asc',
    'columns' => array(
      'bytes_downloaded' => 'bytes_downloaded',
      'bytes_left' => 'bytes_left',
      'bytes_uploaded' => 'bytes_uploaded',
      'download_speed' => 'download_speed',
      'last_announce' => 'last_announce',
      'uid' => 'uid',
      'upload_speed' => 'upload_speed',
    ),
    'info' => array(
      'bytes_downloaded' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'bytes_left' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'bytes_uploaded' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'download_speed' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'last_announce' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'uid' => array(
        'sortable' => 0,
        'separator' => '',
      ),
      'upload_speed' => array(
        'sortable' => 0,
        'separator' => '',
      ),
    ),
    'default' => '-1',
  ));
  $views[$view->name] = $view;
  
  return $views;
}
